part of tecfy_core_client_package;

abstract class IEntityTransaction {
  FutureOr<OperationResultEntityTransaction<Map<String, dynamic>>> beforeAdd(
          BuildContext context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction<Map<String, dynamic>>> beforeUpdate(
          BuildContext context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction<Map<String, dynamic>>> beforeDelete(
          BuildContext context, String id) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction> afterAdd(
          BuildContext context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction> afterUpdate(
          BuildContext context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction> afterDelete(
          BuildContext context, String id) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');
}

class OperationResultEntityTransaction<T> extends OperationResult<T> {
  bool skip;
  OperationResultEntityTransaction(
      {bool success, T data, this.skip, String message})
      : super(data: data, success: success, message: message);
}
