part of tecfy_core_client_package;

class TecfyCoreApp extends StatelessWidget {
  static GlobalKey<NavigatorState> appGlobalkey = GlobalKey<NavigatorState>();
  // static GlobalKey<ScaffoldState> appGlobalPagekey = GlobalKey<ScaffoldState>();
  static set apiURL(v) => ConfigService.apiURL = v;
  static set wsURL(v) => ConfigService.wsURL = v;
  // static String wsURL = '';
  static Map<String, IEntityTransaction> entityServices =
      Map<String, IEntityTransaction>();
  static set themeConfig(IThemeConfig v) => TecfyBasicApp.themeConfig = v;
  static IThemeConfig get themeConfig => TecfyBasicApp.themeConfig;
  static Image logo;
  static Image backgoundImage;
  static ITranslateService translateService;
  static IReportService reportService;
  static void Function(BuildContext) navigateToDefaultPage = (c) =>
      AppNavigator.navigateTo(c, () => DashboardPage(),
          replaceAll: true, animationType: AnimationTypes.opacity);
  static Future Function(Database, int, int) updateSqlLiteDb =
      (d, f, t) async {};
  static int appDbVersion = 0;
  static IMenuInterface menuService;
  static PackageInfo packageInfo;
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    // kReleaseMode;
    // if (kReleaseMode) {
    return StreamBuilder<Language>(
        stream: AppLocale.languageStream,
        initialData: LocalConfigService.language,
        builder: (context, languageSnapshot) {
          AppLocale.appLocale = null;
          return getApp(languageSnapshot.data);
        });
    // } else {
    //   return getApp(LocalConfigService.language);
    // }
  }

  getApp(Language language) {
    return MaterialApp(
      key: UniqueKey(),
      title: 'Application',
      navigatorKey: appGlobalkey,
      theme: ThemeService.getMainThemeAndroid(),
      home: SplashScreenPage(),
      supportedLocales: [const Locale('ar', 'SA'), const Locale('en', 'US')],
      localizationsDelegates: [
        const AppLocalizationsDelegate(),
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate,
        DefaultCupertinoLocalizations.delegate
      ],
      locale: language == Language.arabic
          ? const Locale('ar', 'SA')
          : const Locale('en', 'US'),
      localeResolutionCallback:
          (Locale deviceLocale, Iterable<Locale> supportedLocales) {
        ConfigService.isRTL = (language == Language.arabic);
        var selectedLanguageCode = (language == Language.arabic) ? 'ar' : 'en';
        var lcl = supportedLocales
                .where((d) => d.languageCode == selectedLanguageCode)
                .first ??
            supportedLocales.first;
        return lcl;
      },
    );
  }

  static void init({String mapAPI}) {
    if (!kIsWeb && (Platform.isWindows || Platform.isLinux)) {
      // Initialize FFI
      sqfliteFfiInit();
      // Change the default factory
      databaseFactory = databaseFactoryFfi;
    }
    if (mapAPI != null) {
      //GoogleMap.init(mapAPI);
    }
  }
}
