part of tecfy_core_client_package;

class PropertyNumber extends Property {
  double max;
  double min;
  String format;

  //-------------------------
  //------- Calculated Field
  String calcFormula;
  bool isCalced;
  List<String> calcedProps;
  String formula;
  String formulaType;
  math_expressions.Expression formulaExp;
  List<math_expressions.Variable> formulaExpVariables;

  String sumEntityName;
  String sumPropertyName;

  PropertyNumber({dbName, nameAr, nameEn, valueType: ValueTypes, isRequired})
      : super(
            dbName: dbName,
            nameAr: nameAr,
            nameEn: nameEn,
            valueType: valueType,
            isRequired: isRequired) {
    super.propertyType = PropertyTypes.Number;
  }

  PropertyNumber.fromMap(Map<String, dynamic> row) : super.fromMap(row) {
    calcFormula = row['calcFormula'] ?? '';
    max = row['max'];
    min = row['min'];
    format = row['format'] ?? '';

    if (calcFormula != null && calcFormula.isNotEmpty) {
      isCalced = true;
      var tempList = calcFormula.split(',');
      formulaType = tempList[0];
      if (formulaType == 'Formula') {
        formula = tempList[1];
        calcedProps = tempList.sublist(2);
        var parser = math_expressions.Parser();
        formulaExp =
            parser.parse(formula.replaceAll('e', 'c')); //'(x^2 + cos(y)) / 3'
        formulaExpVariables = calcedProps
            .map((d) => math_expressions.Variable(d.replaceAll('e', 'c')))
            .toList();
      } else if (formulaType == 'SumSub') {
        sumEntityName = lowerFirst(tempList[1]);
        sumPropertyName = lowerFirst(tempList[2]);
      }
    } else
      isCalced = false;
  }

  /*
 keywords['nrt'] = TokenType.ROOT;
    keywords['sqrt'] = TokenType.SQRT;
    keywords['log'] = TokenType.LOG;
    keywords['cos'] = TokenType.COS;
    keywords['sin'] = TokenType.SIN;
    keywords['tan'] = TokenType.TAN;
    keywords['arccos'] = TokenType.ACOS;
    keywords['arcsin'] = TokenType.ASIN;
    keywords['arctan'] = TokenType.ATAN;
    keywords['abs'] = TokenType.ABS;
    keywords['ceil'] = TokenType.CEIL;
    keywords['floor'] = TokenType.FLOOR;
    keywords['sgn'] = TokenType.SGN;
    keywords['ln'] = TokenType.LN;
    keywords['e'] = TokenType.EFUNC;
     */

  double getCalcResult(List<dynamic> vars) {
    var cm = math_expressions.ContextModel();
    for (int i = 0; i < vars.length; i++) {
      cm.bindVariable(
          formulaExpVariables[i], new math_expressions.Number(vars[i]));
    }
    // cm.bindVariable(y, new Number(Math.PI));
    // Evaluate expression:
    try {
      double eval =
          formulaExp.evaluate(math_expressions.EvaluationType.REAL, cm);
      return eval;
    } catch (err) {
      print(err);
      return null;
    }
  }

  @override
  OperationResult isValid(data) {
    if (!super.isValid(data).success) return super.isValid(data);

    return OperationResult(success: true);
  }

  Widget getDisplayWidget(Map<String, dynamic> data,
      {double size = 12, Color color = Colors.black}) {
    String value = '';
    if (data[dbName] == null)
      value = '';
    else if (data[dbName] is int)
      value = data[dbName].toString();
    else if (format != null &&
        format.isNotEmpty &&
        data[dbName] != null &&
        format.contains('.'))
      value =
          data[dbName]?.toStringAsFixed(format.split('.').last.length) ?? '';
    else
      value = data[dbName]?.toStringAsFixed(2) ?? '';

    return Text(value, style: TextStyle(fontSize: size, color: color));
  }

  Future<bool> getDefaultValue(Map<String, dynamic> data) async {
    if (data[dbName] != null) return false;

    return false;
  }
}
