part of tecfy_core_client_package;

class CountryDropdownComponent extends StatefulWidget {
  final String value;
  final dynamic onSelect;
  CountryDropdownComponent(this.value, this.onSelect);
  @override
  _CountryDropdownComponentState createState() =>
      _CountryDropdownComponentState();
}

class _CountryDropdownComponentState extends State<CountryDropdownComponent> {
  String selectedValue ;

  @override
  initState(){
    selectedValue = widget.value ?? '';
    if(selectedValue.isEmpty) selectedValue ='Australia';
    super.initState();
  }

  onSelected(String item) {
    AppNavigator.hapticFeedback(heavy:false);

    selectedValue = item;
    widget.onSelect(item);
    setState(() {});
  }

  onSelectedIos(int item) {
    //selectedValue = item;
    //widget.onSelect(item);
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.stretch,
      children: <Widget>[
        SizedBox(height: 5.0,),
        Text('Country', style: TextStyle(fontSize: 12.0)),
        StreamBuilder<List<String>>(
          // stream: CountryService().getCountries(),
          builder: (_, snap) {
            if (!snap.hasData) return CircularProgressIndicator(valueColor:AlwaysStoppedAnimation<Color>(ThemeService.mainColor));
            return DropdownButtonHideUnderline(child:  
                        
             DropdownButton<String>(
              items: snap.data
                  .map((c) => DropdownMenuItem<String>(
          
                        child:Padding(
                          padding: EdgeInsets.only(left:6),
                          child: Text(c,  style: TextStyle(color:c== selectedValue? null:ThemeService.secondryColor))),
                        value: c,
                      ))
                  .toList(),
              onChanged: onSelected,
              hint: Text('Select Your Country'),
              value: snap.data.any((c)=>c == selectedValue) ? selectedValue : 'Australia',
            )
            
            );
          },
          //
        ),
        Container(height: 1.0, color: Colors.black),
        SizedBox(height: 15.0)
      ],
    );
  }
}
